#ifndef __VALHALL_ENUMS_H_
#define __VALHALL_ENUMS_H_
enum va_atomic_operation {
   VA_ATOMIC_OPERATION_AADD = 2,
   VA_ATOMIC_OPERATION_ASMIN = 8,
   VA_ATOMIC_OPERATION_ASMAX = 9,
   VA_ATOMIC_OPERATION_AUMIN = 10,
   VA_ATOMIC_OPERATION_AUMAX = 11,
   VA_ATOMIC_OPERATION_AAND = 12,
   VA_ATOMIC_OPERATION_AOR = 13,
   VA_ATOMIC_OPERATION_AXOR = 14,
   VA_ATOMIC_OPERATION_AXCHG = 15,
};

enum va_atomic_operation_with_1 {
   VA_ATOMIC_OPERATION_WITH_1_AINC = 0,
   VA_ATOMIC_OPERATION_WITH_1_ADEC = 1,
   VA_ATOMIC_OPERATION_WITH_1_AUMAX1 = 2,
   VA_ATOMIC_OPERATION_WITH_1_ASMAX1 = 3,
   VA_ATOMIC_OPERATION_WITH_1_AOR1 = 4,
};

enum va_clamp {
   VA_CLAMP_NONE = 0,
   VA_CLAMP_CLAMP_0_INF = 1,
   VA_CLAMP_CLAMP_M1_1 = 2,
   VA_CLAMP_CLAMP_0_1 = 3,
};

enum va_combine {
   VA_COMBINE_NONE = 0,
   VA_COMBINE_H0 = 1,
   VA_COMBINE_H1 = 2,
   VA_COMBINE_AND = 3,
   VA_COMBINE_LOWBITS = 4,
};

enum va_condition {
   VA_CONDITION_EQ = 0,
   VA_CONDITION_GT = 1,
   VA_CONDITION_GE = 2,
   VA_CONDITION_NE = 3,
   VA_CONDITION_LT = 4,
   VA_CONDITION_LE = 5,
   VA_CONDITION_GTLT = 6,
   VA_CONDITION_TOTAL = 7,
};

enum va_dimension {
   VA_DIMENSION_1D = 0,
   VA_DIMENSION_2D = 1,
   VA_DIMENSION_3D = 2,
   VA_DIMENSION_CUBE = 3,
};

enum va_fau_special_page_0 {
   VA_FAU_SPECIAL_PAGE_0_WARP_ID = 2,
   VA_FAU_SPECIAL_PAGE_0_FRAMEBUFFER_SIZE = 4,
   VA_FAU_SPECIAL_PAGE_0_ATEST_DATUM = 5,
   VA_FAU_SPECIAL_PAGE_0_SAMPLE = 6,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_0 = 8,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_1 = 9,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_2 = 10,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_3 = 11,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_4 = 12,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_5 = 13,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_6 = 14,
   VA_FAU_SPECIAL_PAGE_0_BLEND_DESCRIPTOR_7 = 15,
};

enum va_fau_special_page_1 {
   VA_FAU_SPECIAL_PAGE_1_THREAD_LOCAL_POINTER = 1,
   VA_FAU_SPECIAL_PAGE_1_WORKGROUP_LOCAL_POINTER = 3,
   VA_FAU_SPECIAL_PAGE_1_RESOURCE_TABLE_POINTER = 7,
};

enum va_fau_special_page_3 {
   VA_FAU_SPECIAL_PAGE_3_LANE_ID = 1,
   VA_FAU_SPECIAL_PAGE_3_CORE_ID = 3,
   VA_FAU_SPECIAL_PAGE_3_PROGRAM_COUNTER = 15,
};

enum va_fetch_component {
   VA_FETCH_COMPONENT_GATHER4_R = 0,
   VA_FETCH_COMPONENT_GATHER4_G = 1,
   VA_FETCH_COMPONENT_GATHER4_B = 2,
   VA_FETCH_COMPONENT_GATHER4_A = 3,
};

enum va_flow {
   VA_FLOW_NONE = 0,
   VA_FLOW_WAIT0 = 1,
   VA_FLOW_WAIT1 = 2,
   VA_FLOW_WAIT01 = 3,
   VA_FLOW_WAIT2 = 4,
   VA_FLOW_WAIT02 = 5,
   VA_FLOW_WAIT12 = 6,
   VA_FLOW_WAIT012 = 7,
   VA_FLOW_WAIT0126 = 8,
   VA_FLOW_WAIT = 9,
   VA_FLOW_RECONVERGE = 10,
   VA_FLOW_DISCARD = 13,
   VA_FLOW_END = 15,
};

enum va_half_swizzles_8_bit {
   VA_HALF_SWIZZLES_8_BIT_B00 = 0,
   VA_HALF_SWIZZLES_8_BIT_B10 = 1,
   VA_HALF_SWIZZLES_8_BIT_B20 = 2,
   VA_HALF_SWIZZLES_8_BIT_B30 = 3,
   VA_HALF_SWIZZLES_8_BIT_B01 = 4,
   VA_HALF_SWIZZLES_8_BIT_B11 = 5,
   VA_HALF_SWIZZLES_8_BIT_B21 = 6,
   VA_HALF_SWIZZLES_8_BIT_B31 = 7,
   VA_HALF_SWIZZLES_8_BIT_B02 = 8,
   VA_HALF_SWIZZLES_8_BIT_B12 = 9,
   VA_HALF_SWIZZLES_8_BIT_B22 = 10,
   VA_HALF_SWIZZLES_8_BIT_B32 = 11,
   VA_HALF_SWIZZLES_8_BIT_B03 = 12,
   VA_HALF_SWIZZLES_8_BIT_B13 = 13,
   VA_HALF_SWIZZLES_8_BIT_B23 = 14,
   VA_HALF_SWIZZLES_8_BIT_B33 = 15,
};

enum va_inactive_result {
   VA_INACTIVE_RESULT_ZERO = 0,
   VA_INACTIVE_RESULT_UMAX = 1,
   VA_INACTIVE_RESULT_I1 = 2,
   VA_INACTIVE_RESULT_V2I1 = 3,
   VA_INACTIVE_RESULT_SMIN = 4,
   VA_INACTIVE_RESULT_SMAX = 5,
   VA_INACTIVE_RESULT_V2SMIN = 6,
   VA_INACTIVE_RESULT_V2SMAX = 7,
   VA_INACTIVE_RESULT_V4SMIN = 8,
   VA_INACTIVE_RESULT_V4SMAX = 9,
   VA_INACTIVE_RESULT_F1 = 10,
   VA_INACTIVE_RESULT_V2F1 = 11,
   VA_INACTIVE_RESULT_INFN = 12,
   VA_INACTIVE_RESULT_INF = 13,
   VA_INACTIVE_RESULT_V2INFN = 14,
   VA_INACTIVE_RESULT_V2INF = 15,
};

enum va_lane_16_bit {
   VA_LANE_16_BIT_H0 = 0,
   VA_LANE_16_BIT_H1 = 1,
};

enum va_lane_8_bit {
   VA_LANE_8_BIT_B0 = 0,
   VA_LANE_8_BIT_B1 = 1,
   VA_LANE_8_BIT_B2 = 2,
   VA_LANE_8_BIT_B3 = 3,
};

enum va_lane_operation {
   VA_LANE_OPERATION_NONE = 0,
   VA_LANE_OPERATION_XOR = 1,
   VA_LANE_OPERATION_ACCUMULATE = 2,
   VA_LANE_OPERATION_SHIFT = 3,
};

enum va_lanes_8_bit {
   VA_LANES_8_BIT_B02 = 0,
   VA_LANES_8_BIT_B00 = 4,
   VA_LANES_8_BIT_B11 = 5,
   VA_LANES_8_BIT_B22 = 6,
   VA_LANES_8_BIT_B33 = 7,
   VA_LANES_8_BIT_B01 = 10,
   VA_LANES_8_BIT_B23 = 11,
};

enum va_load_lane_128_bit {
   VA_LOAD_LANE_128_BIT_IDENTITY = 7,
};

enum va_load_lane_16_bit {
   VA_LOAD_LANE_16_BIT_H0 = 0,
   VA_LOAD_LANE_16_BIT_H1 = 1,
   VA_LOAD_LANE_16_BIT_W0 = 2,
   VA_LOAD_LANE_16_BIT_D0 = 3,
};

enum va_load_lane_24_bit {
   VA_LOAD_LANE_24_BIT_IDENTITY = 0,
};

enum va_load_lane_32_bit {
   VA_LOAD_LANE_32_BIT_W0 = 0,
   VA_LOAD_LANE_32_BIT_D0 = 1,
};

enum va_load_lane_48_bit {
   VA_LOAD_LANE_48_BIT_IDENTITY = 4,
};

enum va_load_lane_64_bit {
   VA_LOAD_LANE_64_BIT_IDENTITY = 7,
};

enum va_load_lane_8_bit {
   VA_LOAD_LANE_8_BIT_B0 = 0,
   VA_LOAD_LANE_8_BIT_B1 = 1,
   VA_LOAD_LANE_8_BIT_B2 = 2,
   VA_LOAD_LANE_8_BIT_B3 = 3,
   VA_LOAD_LANE_8_BIT_H0 = 4,
   VA_LOAD_LANE_8_BIT_H1 = 5,
   VA_LOAD_LANE_8_BIT_W0 = 6,
   VA_LOAD_LANE_8_BIT_D0 = 7,
};

enum va_load_lane_96_bit {
   VA_LOAD_LANE_96_BIT_IDENTITY = 6,
};

enum va_lod_mode {
   VA_LOD_MODE_ZERO = 0,
   VA_LOD_MODE_COMPUTED = 1,
   VA_LOD_MODE_EXPLICIT = 4,
   VA_LOD_MODE_COMPUTED_BIAS = 5,
   VA_LOD_MODE_GRDESC = 6,
};

enum va_memory_access {
   VA_MEMORY_ACCESS_NONE = 0,
   VA_MEMORY_ACCESS_ISTREAM = 1,
   VA_MEMORY_ACCESS_ESTREAM = 2,
   VA_MEMORY_ACCESS_FORCE = 3,
};

enum va_mux {
   VA_MUX_NEG = 0,
   VA_MUX_INT_ZERO = 1,
   VA_MUX_FP_ZERO = 2,
   VA_MUX_BIT = 3,
};

enum va_register_format {
   VA_REGISTER_FORMAT_AUTO = 0,
   VA_REGISTER_FORMAT_F32 = 2,
   VA_REGISTER_FORMAT_F16 = 3,
   VA_REGISTER_FORMAT_S32 = 4,
   VA_REGISTER_FORMAT_S16 = 5,
   VA_REGISTER_FORMAT_U32 = 6,
   VA_REGISTER_FORMAT_U16 = 7,
};

enum va_register_type {
   VA_REGISTER_TYPE_F = 1,
   VA_REGISTER_TYPE_U = 2,
   VA_REGISTER_TYPE_S = 3,
};

enum va_register_width {
   VA_REGISTER_WIDTH_16 = 0,
   VA_REGISTER_WIDTH_32 = 1,
};

enum va_result_type {
   VA_RESULT_TYPE_I1 = 0,
   VA_RESULT_TYPE_F1 = 1,
   VA_RESULT_TYPE_M1 = 2,
   VA_RESULT_TYPE_U1 = 3,
};

enum va_round_mode {
   VA_ROUND_MODE_RTE = 0,
   VA_ROUND_MODE_RTP = 1,
   VA_ROUND_MODE_RTN = 2,
   VA_ROUND_MODE_RTZ = 3,
};

enum va_sample_and_update_mode {
   VA_SAMPLE_AND_UPDATE_MODE_CENTER_STORE = 0,
   VA_SAMPLE_AND_UPDATE_MODE_CENTROID_STORE = 1,
   VA_SAMPLE_AND_UPDATE_MODE_SAMPLE_STORE = 2,
   VA_SAMPLE_AND_UPDATE_MODE_EXPLICIT_STORE = 3,
   VA_SAMPLE_AND_UPDATE_MODE_CENTER_CLOBBER = 4,
   VA_SAMPLE_AND_UPDATE_MODE_SAMPLE_CLOBBER = 6,
   VA_SAMPLE_AND_UPDATE_MODE_RETRIEVE = 7,
};

enum va_sample_mode {
   VA_SAMPLE_MODE_CENTER = 0,
   VA_SAMPLE_MODE_CENTROID = 1,
   VA_SAMPLE_MODE_SAMPLE = 2,
   VA_SAMPLE_MODE_EXPLICIT = 3,
};

enum va_slot {
   VA_SLOT_SLOT0 = 0,
   VA_SLOT_SLOT1 = 1,
   VA_SLOT_SLOT2 = 2,
   VA_SLOT_SLOT7 = 7,
};

enum va_source_format {
   VA_SOURCE_FORMAT_SRC_FLAT32 = 0,
   VA_SOURCE_FORMAT_SRC_FLAT16 = 1,
   VA_SOURCE_FORMAT_SRC_F32 = 2,
   VA_SOURCE_FORMAT_SRC_F16 = 3,
};

enum va_staging_register_count {
   VA_STAGING_REGISTER_COUNT_SR0 = 0,
   VA_STAGING_REGISTER_COUNT_SR1 = 1,
   VA_STAGING_REGISTER_COUNT_SR2 = 2,
   VA_STAGING_REGISTER_COUNT_SR3 = 3,
   VA_STAGING_REGISTER_COUNT_SR4 = 4,
   VA_STAGING_REGISTER_COUNT_SR5 = 5,
   VA_STAGING_REGISTER_COUNT_SR6 = 6,
   VA_STAGING_REGISTER_COUNT_SR7 = 7,
};

enum va_staging_register_write_count {
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE1 = 0,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE2 = 1,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE3 = 2,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE4 = 3,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE5 = 4,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE6 = 5,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE7 = 6,
   VA_STAGING_REGISTER_WRITE_COUNT_WRITE8 = 7,
};

enum va_subgroup_size {
   VA_SUBGROUP_SIZE_SUBGROUP2 = 0,
   VA_SUBGROUP_SIZE_SUBGROUP4 = 1,
   VA_SUBGROUP_SIZE_SUBGROUP8 = 2,
   VA_SUBGROUP_SIZE_SUBGROUP16 = 3,
};

enum va_swizzles_16_bit {
   VA_SWIZZLES_16_BIT_H00 = 0,
   VA_SWIZZLES_16_BIT_H10 = 1,
   VA_SWIZZLES_16_BIT_H01 = 2,
   VA_SWIZZLES_16_BIT_H11 = 3,
   VA_SWIZZLES_16_BIT_B00 = 4,
   VA_SWIZZLES_16_BIT_B20 = 5,
   VA_SWIZZLES_16_BIT_B02 = 6,
   VA_SWIZZLES_16_BIT_B22 = 7,
   VA_SWIZZLES_16_BIT_B11 = 8,
   VA_SWIZZLES_16_BIT_B31 = 9,
   VA_SWIZZLES_16_BIT_B13 = 10,
   VA_SWIZZLES_16_BIT_B33 = 11,
   VA_SWIZZLES_16_BIT_B01 = 12,
   VA_SWIZZLES_16_BIT_B23 = 13,
};

enum va_swizzles_32_bit {
   VA_SWIZZLES_32_BIT_NONE = 0,
   VA_SWIZZLES_32_BIT_H0 = 2,
   VA_SWIZZLES_32_BIT_H1 = 3,
   VA_SWIZZLES_32_BIT_B0 = 4,
   VA_SWIZZLES_32_BIT_B1 = 5,
   VA_SWIZZLES_32_BIT_B2 = 6,
   VA_SWIZZLES_32_BIT_B3 = 7,
};

enum va_swizzles_64_bit {
   VA_SWIZZLES_64_BIT_NONE = 0,
   VA_SWIZZLES_64_BIT_H0 = 2,
   VA_SWIZZLES_64_BIT_H1 = 3,
   VA_SWIZZLES_64_BIT_B0 = 4,
   VA_SWIZZLES_64_BIT_B1 = 5,
   VA_SWIZZLES_64_BIT_B2 = 6,
   VA_SWIZZLES_64_BIT_B3 = 7,
   VA_SWIZZLES_64_BIT_W0 = 8,
};

enum va_swizzles_8_bit {
   VA_SWIZZLES_8_BIT_B0123 = 0,
   VA_SWIZZLES_8_BIT_B3210 = 1,
   VA_SWIZZLES_8_BIT_B0101 = 2,
   VA_SWIZZLES_8_BIT_B2323 = 3,
   VA_SWIZZLES_8_BIT_B0000 = 4,
   VA_SWIZZLES_8_BIT_B1111 = 5,
   VA_SWIZZLES_8_BIT_B2222 = 6,
   VA_SWIZZLES_8_BIT_B3333 = 7,
   VA_SWIZZLES_8_BIT_B2301 = 8,
   VA_SWIZZLES_8_BIT_B1032 = 9,
   VA_SWIZZLES_8_BIT_B0011 = 10,
   VA_SWIZZLES_8_BIT_B2233 = 11,
};

enum va_update_mode {
   VA_UPDATE_MODE_STORE = 0,
   VA_UPDATE_MODE_RETRIEVE = 1,
   VA_UPDATE_MODE_CLOBBER = 3,
};

enum va_varying_texture_register_width {
   VA_VARYING_TEXTURE_REGISTER_WIDTH_16 = 0,
   VA_VARYING_TEXTURE_REGISTER_WIDTH_32 = 1,
   VA_VARYING_TEXTURE_REGISTER_WIDTH_1632 = 2,
   VA_VARYING_TEXTURE_REGISTER_WIDTH_3232 = 3,
};

enum va_vector_size {
   VA_VECTOR_SIZE_NONE = 0,
   VA_VECTOR_SIZE_V2 = 1,
   VA_VECTOR_SIZE_V3 = 2,
   VA_VECTOR_SIZE_V4 = 3,
};

enum va_widen {
   VA_WIDEN_NONE = 0,
   VA_WIDEN_H0 = 1,
   VA_WIDEN_H1 = 2,
};

enum va_write_mask {
   VA_WRITE_MASK_R = 1,
   VA_WRITE_MASK_G = 2,
   VA_WRITE_MASK_RG = 3,
   VA_WRITE_MASK_B = 4,
   VA_WRITE_MASK_RB = 5,
   VA_WRITE_MASK_GB = 6,
   VA_WRITE_MASK_RGB = 7,
   VA_WRITE_MASK_A = 8,
   VA_WRITE_MASK_RA = 9,
   VA_WRITE_MASK_GA = 10,
   VA_WRITE_MASK_RGA = 11,
   VA_WRITE_MASK_BA = 12,
   VA_WRITE_MASK_RBA = 13,
   VA_WRITE_MASK_GBA = 14,
   VA_WRITE_MASK_RGBA = 15,
};

#endif
